/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "addresscontainer.h"

namespace Conexus
{
  namespace Gtk
  {

    AddressContainer::AddressContainer ( unsigned validate ) :
        m_validate_type ( validate )
    {
    }


    AddressContainer::~AddressContainer()
    {
    }

    unsigned AddressContainer::validate_type()
    {
      return m_validate_type;
    }

    void AddressContainer::set_validate_type ( unsigned validate )
    {
      m_validate_type = validate;
      this->on_validate_type_changed();
    }

    void AddressContainer::connect ( Conexus::IPv4::Address& address )
    {
      m_ipv4_address.insert ( &address );
      this->on_connect ( address );
    }

    void AddressContainer::disconnect ( Conexus::IPv4::Address& address )
    {
      m_ipv4_address.erase ( &address );
      this->on_disconnect ( address );
    }

    void AddressContainer::connect ( Conexus::IPv6::Address& address )
    {
      m_ipv6_address.insert ( &address );
      this->on_connect ( address );
    }

    void AddressContainer::disconnect ( Conexus::IPv6::Address& address )
    {
      m_ipv6_address.erase ( &address );
      this->on_disconnect ( address );
    }

    void AddressContainer::on_connect ( Conexus::IPv4::Address& address )
    {
    }

    void AddressContainer::on_disconnect ( Conexus::IPv4::Address& address )
    {
    }

    void AddressContainer::on_connect ( Conexus::IPv6::Address& address )
    {
    }

    void AddressContainer::on_disconnect ( Conexus::IPv6::Address& address )
    {
    }

    void AddressContainer::on_validate_type_changed()
    {
    }

  }

}
