/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSGTKDATAPROGRESSWATCHER_H
#define CONEXUSGTKDATAPROGRESSWATCHER_H

#include <set>
#include <map>

#include <conexus/endpoint.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
     * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
     */
    class DataProgressWatcher
    {
      public:
        DataProgressWatcher();

        virtual ~DataProgressWatcher();

        void add_endpoint ( Conexus::Endpoint::pointer endpoint, bool watch_read=true, bool watch_write=true );

        void remove_endpoint ( Conexus::Endpoint::pointer endpoint );

      protected:
        unsigned m_data_count;

        typedef std::set<Conexus::Endpoint::pointer> Endpoints;
        typedef std::map<Conexus::Endpoint::pointer, sigc::connection> ConnectionMap;

        Endpoints m_endpoints;

        ConnectionMap m_read_connections;
        ConnectionMap m_write_connections;

        virtual void on_read_data ( size_t n ) = 0;

        virtual void on_write_data ( size_t n ) = 0;

      private:
        virtual void on_read_data_proxy ( size_t n );

        virtual void on_write_data_proxy ( size_t n );


    };

  }

}

#endif
