/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSGTKMMDOTTEDDECIMALENTRY_H
#define CONEXUSGTKMMDOTTEDDECIMALENTRY_H

#include <gtkmm.h>

#include <conexus-gtkmm/addresscontainer.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
    @author Rick L Vinyard Jr
    */
    class DottedDecimalEntry : public AddressContainer, public ::Gtk::HBox
    {
      public:
        DottedDecimalEntry();

        ~DottedDecimalEntry();

        std::string get_value_string() const;

      protected:
        ::Gtk::Entry m_entry[4];

        void on_entry_insert_text ( const Glib::ustring& text, int* position, int n );

        virtual void on_connect ( Conexus::IPv4::Address& address );
        virtual void on_connect ( Conexus::IPv6::Address& address );


    };

  }

}

#endif
