/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "factorycombobox.h"

namespace Conexus
{
  namespace Gtk
  {

    std::vector<Glib::RefPtr<Gdk::Pixbuf> > FactoryComboBox::m_pixbuf;

    FactoryComboBox::FactoryComboBox ( Conexus::Factory::pointer factory ) :
        m_factory ( factory )
    {
//     create_pixbufs();

      m_store = ::Gtk::ListStore::create ( m_columns );
      ::Gtk::TreeModel::Row row;

      row = * ( m_store->append() );
      row[ m_columns.name ] = "None";

      if ( m_factory )
      {
        Conexus::Factory::Names::iterator iter;
        for ( iter = m_factory->names().begin(); iter != m_factory->names().end(); iter++ )
        {
          row = * ( m_store->append() );
//         row[ m_columns.picture ] = m_pixbuf[ i ];
          row[ m_columns.name ] = *iter;
        }
      }

      set_model ( m_store );

      pack_start ( m_columns.picture );
      pack_start ( m_columns.name );

      set_active ( 0 );
    }


    FactoryComboBox::~FactoryComboBox()
    {}

    void FactoryComboBox::create_pixbufs()
    {
//     if (m_pixbuf.size() != 0)
//       return;
//
//     Glib::RefPtr<Gdk::Pixbuf> pixbuf;
//     Papyrus::Canvas::pointer canvas = Papyrus::Canvas::create();
//
//     canvas->set_translate( 30, 20 );
//
//     for ( unsigned int i = Cairo::LINE_CAP_BUTT; i <= Cairo::LINE_CAP_SQUARE; i++ ) {
//       canvas->add( Papyrus::example_line_cap( static_cast<Cairo::LineCap>( i ) ) );
//       pixbuf = create_pixbuf( canvas, 60, 40 );
//       m_pixbuf.push_back( pixbuf );
//       canvas->clear();
//     }

    }

  }

}
