/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSGTKFACTORYCOMBOBOX_H
#define CONEXUSGTKFACTORYCOMBOBOX_H

#include <gtkmm/combobox.h>
#include <gtkmm/liststore.h>

#include <conexus/factory.h>
#include <conexus/utility.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
     @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */

    class FactoryComboBox : public ::Gtk::ComboBox
    {
      public:
        FactoryComboBox ( Conexus::Factory::pointer factory = Conexus::__default_factory );

        ~FactoryComboBox();

      protected:
        Conexus::Factory::pointer m_factory;

      class ModelColumns: public ::Gtk::TreeModelColumnRecord
        {
          public:
            ModelColumns()
            {
              add ( picture );
              add ( name );
            }

            ::Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > picture;
            ::Gtk::TreeModelColumn<Glib::ustring> name;
        };

        Glib::RefPtr< ::Gtk::ListStore > m_store;
        ModelColumns m_columns;
        static std::vector<Glib::RefPtr<Gdk::Pixbuf> > m_pixbuf;

        void create_pixbufs();
    };

  }

}

#endif
