/***************************************************************************
 *   Copyright (C) 2009 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSGTKMMNETCOMBOBOX_H
#define CONEXUSGTKMMNETCOMBOBOX_H

#include <gtkmm.h>
#include <hal/libhal.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
    @author Rick L Vinyard Jr
    */
    class NetComboBox : public ::Gtk::ComboBox
    {
      public:
        NetComboBox();

        ~NetComboBox();

        std::string device();

        void set_device ( const std::string& device );

      protected:
        DBusError m_dbus_error;
        LibHalContext *m_hal_ctx;

        bool m_hal_ctx_status;

        void load_from_hal();

      class ModelColumns: public ::Gtk::TreeModel::ColumnRecord
        {
          public:
            ModelColumns()
            {
              add ( description ); add ( device );
            }

            ::Gtk::TreeModelColumn<Glib::ustring> description;
            ::Gtk::TreeModelColumn<Glib::ustring> device;
        };

        ModelColumns m_modelcolumns;
        Glib::RefPtr< ::Gtk::ListStore> m_reftreemodel;

    };

  }

}

#endif
