/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "progressbar.h"

namespace Conexus
{
  namespace Gtk
  {

    ProgressBar::ProgressBar ( unsigned pulse_units )
        : m_pulse_units ( pulse_units )
    {
      this->pulse();
    }


    ProgressBar::~ProgressBar()
    {
    }

    unsigned ProgressBar::pulse_units( )
    {
      return m_pulse_units;
    }

    void ProgressBar::set_pulse_units ( unsigned units )
    {
      m_pulse_units = units;
    }

    void ProgressBar::on_data ( size_t n )
    {
      m_data_count += n;

      if ( m_pulse_units == 0 )
      {
        this->pulse();
      }
      else
      {
        m_data_count += n;
        if ( m_data_count > m_pulse_units )
        {
          for ( unsigned i = 0; i < m_data_count/m_pulse_units; i++ )
            this->pulse();
          m_data_count %= m_pulse_units;
        }
      }
    }

    void ProgressBar::on_read_data ( size_t n )
    {
      this->on_data ( n );
    }

    void ProgressBar::on_write_data ( size_t n )
    {
      this->on_data ( n );
    }

  }

}
