/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSGTKMMPROGRESSBAR_H
#define CONEXUSGTKMMPROGRESSBAR_H

#include <gtkmm/progressbar.h>

#include <conexus-gtkmm/dataprogresswatcher.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class ProgressBar : public ::Gtk::ProgressBar, public DataProgressWatcher
    {
      public:
        ProgressBar ( unsigned pulse_units=0 );

        ~ProgressBar();

        unsigned pulse_units();

        void set_pulse_units ( unsigned units );

      protected:
        unsigned m_pulse_units;

        void on_data ( size_t n );

        virtual void on_read_data ( size_t n );

        virtual void on_write_data ( size_t n );

    };

  }

}

#endif
