/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSGTKMMSPINNER_H
#define CONEXUSGTKMMSPINNER_H

#include <papyrus-gtkmm/viewport.h>
#include <papyrus/affineanimator.h>

#include <conexus-gtkmm/dataprogresswatcher.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class Spinner : public Papyrus::Gtk::Viewport, public DataProgressWatcher
    {
      public:
        Spinner ( unsigned spin_units=0 );

        ~Spinner();

        unsigned spin_units();

        void set_spin_units ( unsigned units );

      protected:
        unsigned m_spin_units;
        unsigned m_data_count;

        Papyrus::AffineAnimator::pointer m_animator;

        void on_data ( size_t n );

        virtual void on_read_data ( size_t n );

        virtual void on_write_data ( size_t n );
    };

  }

}

#endif
