/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "ttyflowcontrolcombobox.h"

namespace Conexus
{
  namespace Gtk
  {

    std::tr1::array<std::string,3> tty_flow_control_string = { {
        "No flow control",
        "Hardware flow control",
        "Software flow control",
      }
    };

    TTYFlowControlComboBox::TTYFlowControlComboBox ( int active )
        : ::Gtk::ComboBoxText()
    {
      for ( unsigned i = 0; i < tty_flow_control_string.size(); i++ )
        this->append_text ( tty_flow_control_string[i] );
      this->set_active ( active );
    }


    TTYFlowControlComboBox::~TTYFlowControlComboBox()
    {
    }

    Conexus::FlowControl TTYFlowControlComboBox::flow_control( )
    {
      return static_cast<Conexus::FlowControl> ( this->get_active_row_number() );
    }

    void TTYFlowControlComboBox::set_flow_control ( Conexus::FlowControl flow_control )
    {
      this->set_active ( flow_control );
    }

  }

}
