/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSMMTTYPARITYERRORCOMBOBOX_H
#define CONEXUSMMTTYPARITYERRORCOMBOBOX_H

#include <gtkmm/comboboxtext.h>

#include <tr1/array>
#include <string>

#include <conexus/tty.h>

namespace Conexus
{
  namespace Gtk
  {

    extern std::tr1::array<std::string,4> tty_parity_error_string;

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class TTYParityErrorComboBox : public ::Gtk::ComboBoxText
    {
      public:
        TTYParityErrorComboBox ( int active=3 );

        ~TTYParityErrorComboBox();

        Conexus::ParityError parity_error();

        void set_parity_error ( Conexus::ParityError error );

    };

  }

}

#endif
