/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSMMTTYSPEEDCOMBOBOX_H
#define CONEXUSMMTTYSPEEDCOMBOBOX_H

#include <gtkmm/comboboxtext.h>

#include <string>
#include <tr1/array>

namespace Conexus
{
  namespace Gtk
  {

    extern std::tr1::array<std::string,31> tty_speed_string;

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class TTYSpeedComboBox : public ::Gtk::ComboBoxText
    {
      public:
        TTYSpeedComboBox ( int active=17 );

        ~TTYSpeedComboBox();

        unsigned speed();

        void set_speed ( unsigned speed );

    };

  }

}

#endif
