/***************************************************************************
 *   Copyright (C) 2007 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSNSSCERTIFICATEDB_H
#define CONEXUSNSSCERTIFICATEDB_H

#include <conexus/pointer.h>
#include <conexus-nss/enums.h>
#include <conexus-nss/certificate.h>
#include <conexus-nss/certificatenicknames.h>

namespace Conexus
{

  namespace NSS
  {

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class CertificateDB
    {
      public:
        typedef ConexusPointer<CertificateDB> pointer;

      protected:
        CertificateDB(CERTCertDBHandle* cobj=NULL);

      public:

        static pointer create(CERTCertDBHandle* cobj);

        /** Returns a smart pointer to the default certificate database */
        static pointer create();
        
        ~CertificateDB();

        // TODO rethink how wincx should be handled
        bool verify_certificate_now( Certificate::pointer cert, bool check_sig, CERT_USAGE usage, void* wincx );

        Certificate::pointer find_certificate_by_name( SECItem* name );

        // TODO rethink how wincx should be handled
        CertificateNicknames::pointer get_certificate_nicknames( NICKNAMES what, void* wincx );

        operator bool();

        void set_cobj( CERTCertDBHandle* cobj );
        
        CERTCertDBHandle* cobj();
        
      protected:
        CERTCertDBHandle* m_cobj;
    };

  }

}

#endif
