/***************************************************************************
 *   Copyright (C) 2007 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "certificatenicknames.h"

#include <cert.h>

namespace Conexus
{

  namespace NSS
  {

    CertificateNicknames::CertificateNicknames( CERTCertNicknames* cobj ):
        m_cobj(cobj)
    {
    }

    CertificateNicknames::pointer CertificateNicknames::create(CERTCertNicknames * cobj)
    {
      return pointer( new CertificateNicknames(cobj) );
    }

    CertificateNicknames::~CertificateNicknames()
    {
      if ( m_cobj ) CERT_FreeNicknames( m_cobj );
    }

    CertificateNicknames::operator bool()
    {
      return m_cobj != NULL;
    }

    void CertificateNicknames::set_cobj(CERTCertNicknames * cobj)
    {
      if ( m_cobj ) CERT_FreeNicknames( m_cobj );
      m_cobj = cobj;
    }

    CERTCertNicknames * CertificateNicknames::cobj()
    {
      return m_cobj;
    }

  }

}
