/***************************************************************************
 *   Copyright (C) 2007 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSNSSCERTIFICATENICKNAMES_H
#define CONEXUSNSSCERTIFICATENICKNAMES_H

#include <certt.h>

#include <conexus/pointer.h>

namespace Conexus
{

  namespace NSS
  {

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class CertificateNicknames
    {
      public:
        typedef ConexusPointer<CertificateNicknames> pointer;

      protected:
        CertificateNicknames( CERTCertNicknames* cobj = NULL );

      public:

        static pointer create(CERTCertNicknames* cobj = NULL);
        
        ~CertificateNicknames();

        operator bool();

        void set_cobj( CERTCertNicknames* cobj );
        
        CERTCertNicknames* cobj();
        
      protected:
        CERTCertNicknames* m_cobj;
    };

  }

}

#endif
