/***************************************************************************
 *   Copyright (C) 2007 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "pk11slot.h"

namespace Conexus
{

  namespace NSS
  {

    PK11Slot::PK11Slot(PK11SlotInfo* cobj):
        m_cobj(cobj)
    {
    }

    PK11Slot::pointer PK11Slot::create(PK11SlotInfo * cobj)
    {
      return pointer( new PK11Slot(cobj) );
    }

    PK11Slot::~PK11Slot()
    {
    }

    const char * PK11Slot::name()
    {
      return PK11_GetSlotName( m_cobj );
    }

    const char* PK11Slot::token_name()
    {
      return PK11_GetTokenName( m_cobj );
    }

    bool PK11Slot::is_hardware()
    {
      return PK11_IsHW( m_cobj );
    }

    bool PK11Slot::is_available()
    {
      return PK11_IsPresent( m_cobj );
    }

    bool PK11Slot::is_readonly()
    {
      return PK11_IsReadOnly( m_cobj );
    }

    PK11Slot::operator bool()
    {
      return m_cobj != NULL;
    }

    void PK11Slot::set_cobj(PK11SlotInfo * cobj)
    {
      m_cobj = cobj;
    }

    PK11SlotInfo * PK11Slot::cobj()
    {
      return m_cobj;
    }

  }

}

