/***************************************************************************
 *   Copyright (C) 2007 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUS_NSSPK11SLOT_H
#define CONEXUS_NSSPK11SLOT_H

#include <pk11func.h>

#include <conexus/pointer.h>

namespace Conexus
{

  namespace NSS
  {

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class PK11Slot
    {
      public:
        typedef ConexusPointer<PK11Slot> pointer;

      protected:
        PK11Slot(PK11SlotInfo* cobj);

      public:
        static pointer create( PK11SlotInfo* cobj = NULL );
        
        ~PK11Slot();

        const char* name();

        const char* token_name();

        bool is_hardware();

        bool is_available();

        bool is_readonly();

        operator bool();

        void set_cobj( PK11SlotInfo* cobj );
        
        PK11SlotInfo* cobj();

      protected:
        PK11SlotInfo* m_cobj;

    };

  }

}

#endif
