/***************************************************************************
 *   Copyright (C) 2007 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUS_NSSPRIVATEKEY_H
#define CONEXUS_NSSPRIVATEKEY_H

#include <keyt.h>

#include <conexus/pointer.h>
#include <conexus-nss/certificate.h>

namespace Conexus
{

  namespace NSS
  {

    /**
      @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
    */
    class PrivateKey
    {
      public:
        typedef ConexusPointer<PrivateKey> pointer;

      protected:
        PrivateKey(SECKEYPrivateKey* key = NULL);

      public:
        static pointer create(SECKEYPrivateKey* key = NULL);
        
        static pointer create( Certificate::pointer cert, void* wincx );

        ~PrivateKey();

        operator bool();

        void set_cobj( SECKEYPrivateKey* cobj );
        
        SECKEYPrivateKey* cobj();

      protected:
        SECKEYPrivateKey* m_cobj;
    };

  }

}

#endif
