/***************************************************************************
 *   Copyright (C) 2008 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSSSLENUMS_H
#define CONEXUSSSLENUMS_H

#include <openssl/ssl.h>

namespace Conexus {
  namespace SSL {

    typedef enum Method
    {
      SSLV2,
      SSLV2_SERVER,
      SSLV2_CLIENT,
      SSLV3,
      SSLV3_SERVER,
      SSLV3_CLIENT,
      TLSV1,
      TLSV1_SERVER,
      TLSV1_CLIENT,
      SSLV23,
      SSLV23_SERVER,
      SSLV23_CLIENT,
      DTLSV1,
      DTLSV1_SERVER,
      DTLSV1_CLIENT,
    } Method;

    typedef enum FileType
    {
      PEM = SSL_FILETYPE_PEM,
      ASN1 = SSL_FILETYPE_ASN1,
    } FileType;

    typedef enum EncDecFlag
    {
      DECRYPTION,
      ENCRYPTION,
    } EncDecFlag;

    typedef enum Verify
    {
      VERIFY_NONE = SSL_VERIFY_NONE,
      VERIFY_PEER = SSL_VERIFY_PEER,
      VERIFY_FAIL_IF_NO_PEER_CERT = SSL_VERIFY_FAIL_IF_NO_PEER_CERT,
      VERIFY_CLIENT_ONCE = SSL_VERIFY_CLIENT_ONCE,
    } Verify;

  }
}

#endif

