/***************************************************************************
 *   Copyright (C) 2008 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSSSLEXCEPT_H
#define CONEXUSSSLEXCEPT_H

/**
 * @defgroup SSLExceptions OpenSSL Exceptions
 */

#include <conexus/except.h>
#include <openssl/err.h>

namespace Conexus
{
  namespace SSL
  {

  /**
   * Base class for all conexus-ssl library exceptions.
   * @author Rick L Vinyard Jr
   * @ingroup SSLExceptions
   */
  class exception: public ::Conexus::conexus_exception
  {
    public:
    exception(unsigned long e=0):
      conexus_exception("Conexus::SSL",0)
    {
      m_return_string = "Conexus::SSL OpenSSL error  Library: ";
      m_return_string += ERR_lib_error_string(e);
      m_return_string += "   Func: ";
      m_return_string += ERR_func_error_string(e);
      m_return_string += "   Reason: ";
      m_return_string += ERR_reason_error_string(e);
    }

    ~exception() throw () { }

    protected:
  };

  }

  void throw_ssl_exception() throw (SSL::exception);
  
}

#endif

