/***************************************************************************
 *   Copyright (C) 2008 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include <conexus-ssl/utility.h>
#include <conexus/utility.h>

#include <openssl/bio.h>
#include <openssl/ssl.h>
#include <openssl/err.h>

#include <conexus-ssl/context.h>

namespace Conexus
{
  namespace SSL
  {

    bool ssl_initialized = false;
    Context::pointer ssl_context;

    void init ( bool use_dispatcher_default, Method method )
    {
      if ( ! Conexus::initialized() )
        Conexus::init ( use_dispatcher_default );

      if ( ! ssl_initialized )
      {
        SSL_library_init();
        SSL_load_error_strings();

        ssl_initialized = true;
      }

      ssl_context = Context::create(method);
    }

    bool initialized()
    {
      return ssl_initialized;
    }

    Context::pointer context()
    {
      return ssl_context;
    }
    
  }

}
