/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "address.h"

#include <cstring>

namespace Conexus
{

  Address::Address( )
  {
    memset( &m_sockaddr, 0x00, sizeof( m_sockaddr ) );
  }

  Address::Address( const struct sockaddr_storage& addr )
  {
    m_sockaddr.storage = addr;
  }

  Address::~Address()
  {}

  const struct sockaddr* Address::sockaddr_ptr() const
  {
    return ( struct sockaddr* ) &m_sockaddr;
  }

  const struct sockaddr_storage* Address::sockaddr_storage_ptr() const
  {
    return & (m_sockaddr.storage);
  }

  socklen_t Address::sockaddr_size() const
  {
    return sizeof( struct sockaddr_storage );
  }

  bool Address::is_broadcast() const
  {
    return false;
  }


}
