/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#include "ip.h"

namespace Conexus
{

  IP::IP ( int domain, int type, int protocol ) : Socket ( domain, type, protocol )
  {
  }

  IP::~IP( ) throw ()
  {
  }

  int IP::ttl( )
  {
    int i;
    this->option ( IPPROTO_IP, IP_TTL, i );
    return i;
  }

  void IP::set_ttl ( int t )
  {
    this->set_option ( IPPROTO_IP, IP_TTL, t );
  }

  TOS IP::tos( )
  {
    int i;
    this->option ( IPPROTO_IP, IP_TOS, i );
    return ( TOS ) i;
  }

  void IP::set_tos ( TOS t )
  {
    this->set_option ( IPPROTO_IP, IP_TOS, t );
  }


}

