#ifndef _DEMOS_H
#define _DEMOS_H

#include "demowindow.h"

typedef sigc::slot<Gtk::Window*> type_slotDo;

struct Demo
{
  const char* title;
  const char* filename;
  //GDoDemoFunc func;
  type_slotDo slot; //The method to call.
  Demo* children;
};


Gtk::Window* do_TTYWidget_demo();
Gtk::Window* do_TTYWidget();
Gtk::Window* do_SerialComboBox();
Gtk::Window* do_NetComboBox();
Gtk::Window* do_TTYByteSizeRadio();
Gtk::Window* do_TTYFlowControlComboBox();
Gtk::Window* do_TTYParityComboBox();
Gtk::Window* do_TTYParityErrorComboBox();
Gtk::Window* do_TTYSpeedComboBox();
Gtk::Window* do_TTYStopBitsRadio();
Gtk::Window* do_DottedDecimalEntry();
Gtk::Window* do_HostEntry();
Gtk::Window* do_PortEntry();
Gtk::Window* do_HostPortEntry();
Gtk::Window* do_EndpointStartStopButton();
Gtk::Window* do_Spinner();
Gtk::Window* do_ProgressBar();
Gtk::Window* do_FactoryComboBox();

Demo tty_demos[] =
{
  { "TTY Widget Demonstration", "example_ttywidget_demo.cpp",  sigc::ptr_fun(&do_TTYWidget_demo), 0 },
  { "TTY Widget", "example_ttywidget.cpp",  sigc::ptr_fun(&do_TTYWidget), 0 },
  { "Serial ComboBox", "example_serialcombobox.cpp",  sigc::ptr_fun(&do_SerialComboBox), 0 },
  { "TTY Byte Size Radio", "example_ttybytesizeradio.cpp",  sigc::ptr_fun(&do_TTYByteSizeRadio), 0 },
  { "TTY Flow-control ComboBox", "example_ttyflowcontrolcombobox.cpp",  sigc::ptr_fun(&do_TTYFlowControlComboBox), 0 },
  { "TTY Parity ComboBox", "example_ttyparitycombobox.cpp",  sigc::ptr_fun(&do_TTYParityComboBox), 0 },
  { "TTY Parity Error ComboBox", "example_ttyparityerrorcombobox.cpp",  sigc::ptr_fun(&do_TTYParityErrorComboBox), 0 },
  { "TTY Speed ComboBox", "example_ttyspeedcombobox.cpp",  sigc::ptr_fun(&do_TTYSpeedComboBox), 0 },
  { "TTY Stop Bits Radio", "example_ttystopbitsradio.cpp",  sigc::ptr_fun(&do_TTYStopBitsRadio), 0 },
  { 0, 0, type_slotDo(), 0 }
};

Demo ip_demos[] =
{
  { "Dotted Decimal Entry", "example_dotteddecimalentry.cpp",  sigc::ptr_fun(&do_DottedDecimalEntry), 0 },
  { "Network ComboBox", "example_netcombobox.cpp",  sigc::ptr_fun(&do_NetComboBox), 0 },
  { "Host Entry", "example_hostentry.cpp",  sigc::ptr_fun(&do_HostEntry), 0 },
  { "Port Entry", "example_portentry.cpp",  sigc::ptr_fun(&do_PortEntry), 0 },
  { "Host and Port Entry", "example_hostportentry.cpp",  sigc::ptr_fun(&do_HostPortEntry), 0 },
  { 0, 0, type_slotDo(), 0 }
};

Demo general_demos[] =
{
  { "Endpoint Stop/Start Button", "example_endpointstartstopbutton.cpp",  sigc::ptr_fun(&do_EndpointStartStopButton), 0 },
  { "Factory ComboBox", "example_factorycombobox.cpp",  sigc::ptr_fun(&do_FactoryComboBox), 0 },
  { 0, 0, type_slotDo(), 0 }
};

Demo progress_indicators[] =
{
  { "Spinner", "example_spinner.cpp",  sigc::ptr_fun(&do_Spinner), 0 },
  { "Progress Bar", "example_progressbar.cpp",  sigc::ptr_fun(&do_ProgressBar), 0 },
  { 0, 0, type_slotDo(), 0 }
};

Demo testgtk_demos[] =
{
  { "Serial port and TTY Widgets", "",  type_slotDo(), tty_demos },
  { "IPv4 and IPv6 Widgets", "",  type_slotDo(), ip_demos },
  { "Progress Indicators", "",  type_slotDo(), progress_indicators },
  { "General Purpose Widgets", "",  type_slotDo(), general_demos },
  { 0, 0, type_slotDo(), 0 }
};

#endif //_DEMOS_H

